// MultiMookRoller.js
//
// This macro does a quick roll that includes a trait roll and wild die into the
// chat window.  Great for quick extra rolls without having to create an NPC sheet.
//
// Carl Davis (copyright 2022) - asavageworldsgm@gmail.com
main();

async function main()
{

  let dieSides = 4;

  new Dialog({
    title: "Multi-Mook Roller",
    content:
      'Number of Mooks: <form>    <input type="text" name="baseinput" placeholder="Number of Extras">    </form>'
      ,

    buttons: {
      d4: {
        label: "d4",
        callback: (html) => {
          let baseInput = html.find('[name="baseinput"]').val();
          doRoll(4, baseInput);

        }
      },
      d6: {
        label: "d6",
        callback: (html) => {
          let baseInput = html.find('[name="baseinput"]').val();
          doRoll(6, baseInput);
      }
      },
      d8: {
        label: "d8",
        callback: (html) => {
          let baseInput = html.find('[name="baseinput"]').val();
          doRoll(8, baseInput);
        }
      },
      d10: {
        label: "d10",
        callback: (html) => {
          let baseInput = html.find('[name="baseinput"]').val();
          doRoll(10, baseInput);
        }
      },
      d12: {
        label: "d12",
        callback: (html) => {
          let baseInput = html.find('[name="baseinput"]').val();
          doRoll(12, baseInput);
        }
      },

      close: {
        label: "Close"
      }
    }
  }).render(true);

}

// Rolls the trait die passed in and a wild die. The results are sent to the chat window.
async function doRoll(dieSides, numberOfRolls)
{
  //console.log(dieSides);

  let message = "";

  for (let i=0; i < numberOfRolls; i++)
  {
  // Roll Attack
    let traitRoll = `1d${dieSides}x`;
    let theRoll = new Roll(traitRoll);
    let roll = await theRoll.evaluate();
    //
    // Here is the wild die sides ... change if needed for your game.
    //
    let wildDie = 6;
    let wdtheRoll = new Roll("1d" + wildDie + "x")
    let wdRoll = await wdtheRoll.evaluate();

    console.log(roll);
    console.log(wdRoll);
    message = message + "<p><b>Extra " + (i+1) + " Rolls</b>: [" + roll.total + "]; wild die [" + wdRoll.total + "]</p>"
  }

  ChatMessage.create({
           speaker: {
             alias: ""
           },
           content: message

         });

}
